#include <stdio.h>
#include <math.h>
#define BYTE    unsigned char
#define margin  100               // Y_direct, delete edge
#define thr      99               // ~99  corss grey_level
#define t15      15               // min cross length
#define t40      40               // max cross length
#define  n9      11               // center_BOX
#define n92      n9/2             // half center_BOX
BYTE tt[4000];                    // findcross work temp_array, assume, n2<4000
int  bm;                          // bm=8, 256color;  =24, 16m color
BYTE *bmp1,*tmp1[2];              // array pointer of 2 file 256 color.
BYTE *bmp3[3],*tmp3[2][3];        // array pointer of 2 file 16m color.
int n1,n2,m1,m2,m21,it;           // n1=3439; n2=2439; & output size 
double a1,a2,a3,a4,a5,a6;         // 6 transfer parms
short h[27+512];                  // BMP head
int  main_porc(char *img1,char *img2);
int  read_bmp(char *f2,int ty1);
int  findcross1(BYTE *a,int n1,int *x,int *y,int *ty);
int  findcross2(BYTE *a,int n1,int v0,int *x,int *y);
void center(BYTE *a,int n1,int x0,int y0,float *x,float *y);
void work(BYTE *a,int n1,BYTE *b,int ty);
void writebmp(char *f2);

main(int ac,char **av)
{
  if(ac<3){ printf("\n\t ****** combine 2 scan_16m/256_bmp *******\n");
            printf("\n\t                       jiang, 2013,4,3\n");
            printf("\n\t comb f1[.bmp] f2[.bmp] [!]");
            printf("\n\t ! means: print more\n");
            return(0); }
  it=(ac>3)?1:0;
  if(!main_porc(av[1],av[2]))return(0);   // 0: fail;  1: ok
}

int main_porc(char *img1,char *img2)
{
  int i,k,u1,v1,u2,v2,ty,ty1=-1,ip=0; char f1[40],f2[40],f11[40];
  float p5x,p5y,p6x,p6y; double cosa,sina,z,r; BYTE *a,*b;
  int err=1;
l10:
  if(ip)strcpy(f1,img2); else strcpy(f1,img1);
  for(i=0;i<strlen(f1);i++)if(f1[i]=='.')break; f1[i]=0;
  sprintf(f2,"%s.bmp",f1);
  if(!read_bmp(f2,ty1))goto l00;               // read BMP file
  if(bm==8)a=(BYTE *)bmp1; else a=(BYTE *)bmp3[0];
                             // use 0, B_color to find cross; 1,2 also ok !!! 
  if(!findcross1(a,n1,&u1,&v1,&ty))goto l00;   // roughly finding cross
  if(!findcross2(a,n1,v1,&u2,&v2))goto l00;    // left mark
  center(a,n1,u1,v1,&p5x,&p5y);                // improve corss position
  center(a,n1,u2,v2,&p6x,&p6y);
  if(ty==ty1){ printf("you use 2 same part of IMG_file\n"); goto l00; }
  z=(p6y-p5y)/(p6x-p5x);  z=atan(z); cosa=cos(z); sina=sin(z);
  z=sqrt((p5x-p6x)*(p5x-p6x)+(p5y-p6y)*(p5y-p6y));
  if(it)printf("cosa,sina,R: %lf %lf %lf\n",cosa,sina,z);
  a1=a4=cosa; a2=sina;  a3=-a2; a5=p5x; a6=p5y;
                                    // bottm_part'R  normalized by  up_part
  if(!ip)r=z; else { k=r-z; if(k<0)k=-k; if(k<5)a1*=z/r; 
    if(it)printf("R adjust: %lf %lf a1=%lf\n",r,z,a1);
  }
  m1=r;  m2=ty?p5y-margin:n2-p5y-margin;
  printf("%s  type= %d   %d*%d\n",f2,ty,m1,m2);
  if(bm==8){ tmp1[ty]=(BYTE *)malloc(m1*m2);
    if(!tmp1[ty]){ printf("Fail alloc memory!\n"); goto l00; }
    b=(BYTE *)tmp1[ty]; work(a,n1,b,ty);
  } else {
    for(i=0;i<3;i++){
      tmp3[ty][i]=(BYTE *)malloc(m1*m2);
      if(!tmp3[ty][i]){printf("Fail alloc memory!\n"); goto l00;}
      a=(BYTE *)bmp3[i]; b=(BYTE *)tmp3[ty][i]; work(a,n1,b,ty);
    }
  }
  if(!ip){ m21=m2; ty1=ty; strcpy(f11,f1); ip++; goto l10; }
  if(!ty){ i=m2; m2=m21; m21=i; }
  sprintf(f2,"%s_%s.bmp",f11,&f1[strlen(f1)-2]);
  printf(" ===> %s   %d*%d",f2,m1,m2+m21);
  writebmp(f2);  printf(" ok!\n");
l01:
  for(i=0;i<3;i++){ free(bmp3[i]); free(tmp3[0][i]); free(tmp3[1][i]); }
  return(err);
l00: err=0; goto l01;
}

void writebmp(char *f2)
{
  int i,j,k,l,m[2]; FILE *fp; BYTE *a,*b[3];
  fp=fopen(f2,"wb"); h[9]=m1; h[11]=m2+m21; m[0]=m2; m[1]=m21;
  if(bm==8){ k=(4-m1%4)%4;
    j=(m1+k)*m2+1078; h[1]=j; h[2]=j>>16; fwrite(h,2,539,fp);
    for(l=0;l<2;l++){ a=(BYTE *)tmp1[1-l];
      for(j=0;j<m[l];j++){ fwrite(a,1,m1+k,fp); (BYTE *)a+=m1; } 
    }
  } else { k=(4-3*m1%4)%4;
    j=(m1*3+k)*m2+54; h[1]=j; h[2]=j>>16; fwrite(h,2,27,fp); k+=3*m1; 
    for(l=0;l<2;l++){
      for(i=0;i<3;i++)b[i]=(BYTE *)tmp3[1-l][i];
      for(j=0;j<m[l];j++){ a=(BYTE *)bmp3[0];         // temp work array
        for(i=0;i<m1;i++){ *a++=*b[0]++; *a++=*b[1]++; *a++=*b[2]++; }
        a=(BYTE *)bmp3[0]; fwrite(a,1,k,fp);
      } 
    }
  } fclose(fp);
}

int read_bmp(char *f2,int ty1)
{
  FILE *fp; int i,j,k; BYTE *a,*b,*b0,*b1,*b2;
  fp=fopen(f2,"rb"); if(!fp){printf("%s not found!\n",f2); return(0); }
  fread(h,2,27,fp);
  if(ty1==-1)bm=h[14]; else if(bm!=h[14])
    { fclose(fp); printf("%s not color BMP!\n",f2); return(0); }
  n1=h[9];  n2=h[11];
  if(bm==8){ k=(4-n1%4)%4; fread(&h[27],2,512,fp);
    free(bmp1); bmp1=(BYTE *)malloc(n1*n2);
    if(!bmp1){printf("Fail alloc memory!\n"); return(0); }
    a=(BYTE *)bmp1; for(j=0;j<n2;j++){ fread(a,1,n1+k,fp); (BYTE *)a+=n1; }
  } else { k=(4-3*n1%4)%4+3*n1;
    for(i=0;i<3;i++){ free(bmp3[i]);  bmp3[i]=(BYTE *)malloc(n1*n2); 
                      if(!bmp3[i]){printf("Fail alloc memory!\n"); return(0); }}
    a=(BYTE *)malloc(k);    if(!a){printf("Fail alloc memory!\n"); return(0); }
    b0=(BYTE *)bmp3[0]; b1=(BYTE *)bmp3[1]; b2=(BYTE *)bmp3[2];
    for(j=0;j<n2;j++){ b=(BYTE *)a; fread(b,1,k,fp);  
      for(i=0;i<n1;i++){ *b0++=*b++; *b1++=*b++; *b2++=*b++; }
    } free(a);
  } fclose(fp);
  return(1);
}

void work(a,n1,b,ty)
BYTE *a,*b; int n1,ty;
{
  int i,j, ix,iy,u,v; float x,y, wx,wy,ux,uy, z0,z1,z2,z3;
  if(!ty){
    for(j=0;j<m2;j++)for(i=0;i<m1;i++){
      x=a1*i+a3*j+a5;   y=a2*i+a4*j+a6;
      ix=x; wx=x-ix; ux=1.-wx; iy=y; wy=y-iy; uy=1.-wy;
      z0=ux*uy; z1=wx*uy; z2=ux*wy; z3=wx*wy; u=n1*iy+ix; v=u+n1;
      *b++=a[u]*z0+a[u+1]*z1+a[v]*z2+a[v+1]*z3;
    }
  } else {           
    for(j=m2-1;j>=0;j--)for(i=0;i<m1;i++){
      x=a1*i-a3*j+a5;   y=a2*i-a4*j+a6;
      ix=x; wx=x-ix; ux=1.-wx; iy=y; wy=y-iy; uy=1.-wy;
      z0=ux*uy; z1=wx*uy; z2=ux*wy; z3=wx*wy; u=n1*iy+ix; v=u+n1;
      *b++=a[u]*z0+a[u+1]*z1+a[v]*z2+a[v+1]*z3;
    }
  }
}

void center(a,n1,x0,y0,x,y)
BYTE *a; int n1,x0,y0; float *x,*y;
{
  int i,j,k,u,v; float d[n9][n9],e[n9],z;
  for(j=y0-n92,v=0;j<=y0+n92;j++,v++)for(i=x0-n92,u=0;i<=x0+n92;i++,u++){
    k=a[j*n1+i]; k=255-k-thr; if(k<0)k=0; d[v][u]=k; }
//for(j=0;j<n9;j++){ for(i=0;i<n9;i++)printf("%6.1f",d[j][i]); printf("\n");}
  for(i=0;i<n9;i++){ e[i]=0; for(j=0;j<n9;j++)e[i]+=d[j][i]; }
//for(i=0;i<n9;i++)printf("%f ",e[i]); printf("\n");
  z=0; for(i=1;i<n9-1;i++)if(e[i]>z){ j=i; z=e[i]; }
  *x=(e[j-1]-e[j+1])*0.5/(e[j-1]+e[j+1]-e[j]*2)+j+x0-n92;
  for(j=0;j<n9;j++){ e[j]=0; for(i=0;i<n9;i++)e[j]+=d[j][i]; }
//for(i=0;i<n9;i++)printf("%f ",e[i]); printf("\n");
  z=0; for(i=1;i<n9-1;i++)if(e[i]>z){ j=i; z=e[i]; }
  *y=(e[j-1]-e[j+1])*0.5/(e[j-1]+e[j+1]-e[j]*2)+j+y0-n92;
  if(it)printf("%d %d ==> %6.1f %6.1f\n",x0,y0,*x,*y);
}

findcross1(a,n1,x,y,ty)
BYTE *a;  int n1,*x,*y,*ty;
{
  int i,j,k, k0,k1,k2,k3,k4=n1/6,k5,k6,d[8];
  for(j=20;j<n2-20;j++)tt[j]=0;
l00:                         // if find false cross, find cross again
  for(j=20;j<n2-20;j++){ k3=1;  k0=0; if(tt[j])continue;
    for(i=0;i<n1/6;i++){ k=a[j*n1+i]; k=255-k;
      if(k>thr){ if(k3)continue; k0=1; k2=i; 
        for(k1=i+1;k1<n1/6;k1++){
          k=a[j*n1+k1];k=255-k;if(k<thr)break; else k0++;
        }
      } else k3=0;
      if(k0>t15 && k0<t40)goto l001;
    }
l001:
    if(k0>t15 && k0<t40){ // if(it)printf("%d %d %d\n",k2,j,k0);
      if(k2<=k4){
        if(k2<k4){ k4=k2; k5=j; k6=k0; }
        if(k2==k4 && k0>k6){ k5=j; k6=k0; }
      }
    }        
  } if(k4==n1/6){ printf("Cannot found corss1 !\n"); return(0); }
// get cross half_x len
  k0=0;
  for(j=k5-6;j<=k5+6;j++){ if(j>=k5-2 && j<=k5+2)continue;
    for(i=k4;i<k4+t40;i++){ k=a[j*n1+i]; k=255-k; if(k>thr)break;
    } d[k0++]=i; 
    if(i==k4+t40){ for(i=k5-6;i<=k5+6;i++)tt[i]=1; goto l00; }  // false
  } median(d,k0,&i);
  if(i-k4<6) { for(i=k5-6;i<=k5+6;i++)tt[i]=1; goto l00; }     // false
  *x=i+1; *y=k5; *ty=0; if(k5>n2/2)*ty=1;
  if(it)printf("--->X,Y: %d %d (%d)\n",k4,k5,k6);
  return(1);
}

int findcross2(a,n1,v0,x,y)
BYTE *a;  int n1,v0,*x,*y;
{
  int i,j,k,j1,j2, k0,k1,k2,k3,k4=n1*5/6,k5,k6,d[8];
  j1=v0-100; j2=v0+100; if(j1<20)j1=20; if(j2>n2-20)j2=n2-20;
  for(j=j1;j<j2;j++)tt[j]=0;
l00:
  for(j=j1;j<j2;j++){  k3=1;  k0=0; if(tt[j])continue;
    for(i=n1-1;i>n1*5/6;i--){ k=a[j*n1+i];k=255-k;
      if(k>thr){ if(k3)continue; k0=1; k2=i; 
        for(k1=i-1;k1>n1*5/6;k1--){
          k=a[j*n1+k1];k=255-k;if(k<thr)break; else k0++;
        }
      } else k3=0;
      if(k0>t15 && k0<t40)goto l001;
    }
l001:
    if(k0>t15 && k0<t40){ // if(it)printf("%d %d %d\n",k2,j,k0);
      if(k2>=k4){
        if(k2>k4){ k4=k2; k5=j; k6=k0; }
        if(k2==k4 && k0>k6){ k5=j; k6=k0; }
      }
    }        
  } if(k4==n1*5/6){ printf("Cannot found corss2 !\n"); return(0); }
// get cross half_x len
  k0=0;
  for(j=k5-6;j<=k5+6;j++){ if(j>=k5-2 && j<=k5+2)continue;
    for(i=k4;i>k4-t40;i--){ k=a[j*n1+i]; k=255-k; if(k>thr)break;
    } d[k0++]=i; 
    if(i==k4+t40){ for(i=k5-6;i<=k5+6;i++)tt[i]=1; goto l00; }  // false
  } median(d,k0,&i);
  if(k4-i<6) { for(i=k5-6;i<=k5+6;i++)tt[i]=1; goto l00; }     // false
  *x=i-1; *y=k5;
  if(it)printf("--->X,Y: %d %d (%d)\n",k4,k5,k6);
  return(1);
}

median(int *a,int m,int *x)
{
  int i,j,z;
  for(i=0;i<m-1;i++)for(j=i+1;j<m;j++)if(a[i]>a[j]){
    z=a[i]; a[i]=a[j]; a[j]=z; }
  j=m/2; *x=(m%2)?a[j]:(a[j-1]+a[j])/2.;
}
